> For clean Markdown content of this page, append .md to this URL. For the complete documentation index, see https://learning.postman.com/llms.txt. For full content including API reference and SDK examples, see https://learning.postman.com/llms-full.txt.

# Generate a collection from spec

POST https://api.getpostman.com/specs/{specId}/generations/{elementType}
Content-Type: application/json

Creates a collection from the given OpenAPI 2.0, 3.0, or 3.1 specification or Smithy specification. The response contains a polling link to the task status.

Reference: https://learning.postman.com/api-docs/api-reference/specs/generate-collection

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: Postman API
  version: 1.0.0
paths:
  /specs/{specId}/generations/{elementType}:
    post:
      operationId: generateCollection
      summary: Generate a collection from spec
      description: >-
        Creates a collection from the given OpenAPI 2.0, 3.0, or 3.1
        specification or Smithy specification. The response contains a polling
        link to the task status.
      tags:
        - specs
      parameters:
        - name: specId
          in: path
          description: The spec's ID.
          required: true
          schema:
            $ref: '#/components/schemas/specId'
        - name: elementType
          in: path
          description: The `collection` element type.
          required: true
          schema:
            $ref: '#/components/schemas/elementTypeCollection'
        - name: x-api-key
          in: header
          required: true
          schema:
            type: string
      responses:
        '202':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/generateTaskResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/GenerateCollectionRequestForbiddenError'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '423':
          description: Locked
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/GenerateCollectionRequestInternalServerError
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/generateCollection'
servers:
  - url: https://api.getpostman.com
    description: https://api.getpostman.com
  - url: https://api.eu.postman.com
    description: https://api.eu.postman.com
components:
  schemas:
    specId:
      type: string
      title: specId
    elementTypeCollection:
      type: string
      enum:
        - collection
      title: elementTypeCollection
    GenerateCollectionOptionsRequestNameSource:
      type: string
      enum:
        - Fallback
        - URL
      default: Fallback
      description: >
        Determines how the generated collection's requests are named. If the
        `Fallback` value is passed, then the request is named after one of the
        following values in the schema:

        - `summary`

        - `operationId`

        - `description`

        - `url`
      title: GenerateCollectionOptionsRequestNameSource
    GenerateCollectionOptionsIndentCharacter:
      type: string
      enum:
        - Tab
        - Space
      default: Space
      description: The option for setting the indentation character type.
      title: GenerateCollectionOptionsIndentCharacter
    GenerateCollectionOptionsFolderStrategy:
      type: string
      enum:
        - Paths
        - Tags
      default: Paths
      description: >-
        Whether to create folders based on the specification's `paths` or `tags`
        properties.
      title: GenerateCollectionOptionsFolderStrategy
    generateCollectionOptions:
      type: object
      properties:
        requestNameSource:
          $ref: '#/components/schemas/GenerateCollectionOptionsRequestNameSource'
          default: Fallback
          description: >
            Determines how the generated collection's requests are named. If the
            `Fallback` value is passed, then the request is named after one of
            the following values in the schema:

            - `summary`

            - `operationId`

            - `description`

            - `url`
        indentCharacter:
          $ref: '#/components/schemas/GenerateCollectionOptionsIndentCharacter'
          default: Space
          description: The option for setting the indentation character type.
        parametersResolution:
          type: string
          default: Schema
          description: >-
            Generated collections use examples for parameter generation by
            default. Any existing collections generated using the schema
            parameter generation will continue to sync using their existing
            strategy.
        folderStrategy:
          $ref: '#/components/schemas/GenerateCollectionOptionsFolderStrategy'
          default: Paths
          description: >-
            Whether to create folders based on the specification's `paths` or
            `tags` properties.
        includeAuthInfoInExample:
          type: boolean
          default: true
          description: >-
            If true, include the authentication parameters in the example
            request.
        enableOptionalParameters:
          type: boolean
          default: true
          description: >-
            If true, enables optional parameters in the collection and its
            requests.
        keepImplicitHeaders:
          type: boolean
          default: false
          description: >-
            If true, keep the implicit headers from the OpenAPI specification,
            which are removed by default.
        includeDeprecated:
          type: boolean
          default: true
          description: >-
            If true, includes all deprecated operations, parameters, and
            properties in generated collection.
        alwaysInheritAuthentication:
          type: boolean
          default: false
          description: >-
            Whether authentication details should be included in all requests,
            or always inherited from the collection.
        nestedFolderHierarchy:
          type: boolean
          default: false
          description: >-
            If true, creates subfolders in the generated collection based on the
            order of the endpoints' tags.
      description: >-
        The advanced creation options and their values. For more details, see
        Postman's [OpenAPI to Postman Collection Converter OPTIONS
        documentation](https://github.com/postmanlabs/openapi-to-postman/blob/develop/OPTIONS.md).
        These properties are case-sensitive.
      title: generateCollectionOptions
    generateCollection:
      type: object
      properties:
        name:
          type: string
          description: The generated collection's name.
        options:
          $ref: '#/components/schemas/generateCollectionOptions'
      required:
        - name
        - options
      title: generateCollection
    generateTaskResponse:
      type: object
      properties:
        taskId:
          type: string
          description: >-
            The created task ID. You can use this ID to track the status of the
            task.
        url:
          type: string
          description: The URL to get or poll the status of a generated spec task.
      title: generateTaskResponse
    CommonErrorTypeTitleDetailStatusType:
      oneOf:
        - type: string
          format: uri-reference
        - type: string
      title: CommonErrorTypeTitleDetailStatusType
    commonErrorTypeTitleDetailStatus:
      type: object
      properties:
        type:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailStatusType'
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: Information about the error.
        status:
          type: integer
          description: The error's HTTP status code.
      title: commonErrorTypeTitleDetailStatus
    commonErrorTypeTitleDetailStatusInstance:
      type: object
      properties:
        type:
          type: string
          format: uri-reference
          description: >-
            The [URI reference](https://www.rfc-editor.org/rfc/rfc3986) that
            identifies the type of problem.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          type: string
          description: An explanation about the problem.
        status:
          type: integer
          description: The HTTP status code generated by the origin server.
        instance:
          type: string
          description: >-
            The URI reference that identifies the specific occurrence of the
            problem.
      title: commonErrorTypeTitleDetailStatusInstance
    GenerateCollectionRequestForbiddenError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatusInstance'
      title: GenerateCollectionRequestForbiddenError
    CommonErrorTypeTitleDetailDetail:
      oneOf:
        - type: string
        - type: object
          additionalProperties:
            description: Any type
      description: Information about the error.
      title: CommonErrorTypeTitleDetailDetail
    commonErrorTypeTitleDetail:
      type: object
      properties:
        type:
          type: string
          description: The type of error.
        title:
          type: string
          description: A short summary of the problem.
        detail:
          $ref: '#/components/schemas/CommonErrorTypeTitleDetailDetail'
          description: Information about the error.
      title: commonErrorTypeTitleDetail
    CommonErrorNameMessageError:
      type: object
      properties:
        name:
          type: string
          description: The error name.
        message:
          type: string
          description: The error message.
      description: Information about the error.
      title: CommonErrorNameMessageError
    commonErrorNameMessage:
      type: object
      properties:
        error:
          $ref: '#/components/schemas/CommonErrorNameMessageError'
          description: Information about the error.
      title: commonErrorNameMessage
    GenerateCollectionRequestInternalServerError:
      oneOf:
        - $ref: '#/components/schemas/commonErrorTypeTitleDetail'
        - $ref: '#/components/schemas/commonErrorTypeTitleDetailStatus'
        - $ref: '#/components/schemas/commonErrorNameMessage'
      title: GenerateCollectionRequestInternalServerError
  securitySchemes:
    PostmanApiKey:
      type: apiKey
      in: header
      name: x-api-key
    scimApiKey:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        A valid [SCIM API
        key](https://learning.postman.com/docs/administration/scim-provisioning/scim-provisioning-overview/#generating-scim-api-key)
        for calls to SCIM endpoints.
    basicAuth:
      type: http
      scheme: basic

```

## Examples

### Generate Spec Task



**Request**

```json
undefined
```

**Response**

```json
{
  "taskId": "66ae9950-0869-4e65-96b0-1e0e47e771af",
  "url": "/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/tasks/66ae9950-0869-4e65-96b0-1e0e47e771af"
}
```

**SDK Code**

```python Generate Spec Task
import requests

url = "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection"

headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, headers=headers)

print(response.json())
```

```javascript Generate Spec Task
const url = 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: undefined
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Generate Spec Task
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Generate Spec Task
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'

response = http.request(request)
puts response.read_body
```

```java Generate Spec Task
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .asString();
```

```php Generate Spec Task
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection', [
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Generate Spec Task
using RestSharp;

var client = new RestClient("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
IRestResponse response = client.Execute(request);
```

```swift Generate Spec Task
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Generate Collection Task



**Request**

```json
undefined
```

**Response**

```json
{
  "taskId": "66ae9950-0869-4e65-96b0-1e0e47e771af",
  "url": "/collections/12345678-12ece9e1-2abf-4edc-8e34-de66e74114d2/tasks/66ae9950-0869-4e65-96b0-1e0e47e771af"
}
```

**SDK Code**

```python Generate Collection Task
import requests

url = "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection"

headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, headers=headers)

print(response.json())
```

```javascript Generate Collection Task
const url = 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: undefined
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Generate Collection Task
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection"

	req, _ := http.NewRequest("POST", url, nil)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Generate Collection Task
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'

response = http.request(request)
puts response.read_body
```

```java Generate Collection Task
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .asString();
```

```php Generate Collection Task
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection', [
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Generate Collection Task
using RestSharp;

var client = new RestClient("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
IRestResponse response = client.Execute(request);
```

```swift Generate Collection Task
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Generate a Collection



**Request**

```json
{
  "name": "Sample API",
  "options": {
    "folderStrategy": "Tags",
    "enableOptionalParameters": true
  }
}
```

**Response**

```json
{
  "taskId": "66ae9950-0869-4e65-96b0-1e0e47e771af",
  "url": "/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/tasks/66ae9950-0869-4e65-96b0-1e0e47e771af"
}
```

**SDK Code**

```python Generate a Collection
import requests

url = "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection"

payload = {
    "name": "Sample API",
    "options": {
        "folderStrategy": "Tags",
        "enableOptionalParameters": True
    }
}
headers = {
    "x-api-key": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Generate a Collection
const url = 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection';
const options = {
  method: 'POST',
  headers: {'x-api-key': '<apiKey>', 'Content-Type': 'application/json'},
  body: '{"name":"Sample API","options":{"folderStrategy":"Tags","enableOptionalParameters":true}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Generate a Collection
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection"

	payload := strings.NewReader("{\n  \"name\": \"Sample API\",\n  \"options\": {\n    \"folderStrategy\": \"Tags\",\n    \"enableOptionalParameters\": true\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("x-api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Generate a Collection
require 'uri'
require 'net/http'

url = URI("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["x-api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Sample API\",\n  \"options\": {\n    \"folderStrategy\": \"Tags\",\n    \"enableOptionalParameters\": true\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java Generate a Collection
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")
  .header("x-api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Sample API\",\n  \"options\": {\n    \"folderStrategy\": \"Tags\",\n    \"enableOptionalParameters\": true\n  }\n}")
  .asString();
```

```php Generate a Collection
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection', [
  'body' => '{
  "name": "Sample API",
  "options": {
    "folderStrategy": "Tags",
    "enableOptionalParameters": true
  }
}',
  'headers' => [
    'Content-Type' => 'application/json',
    'x-api-key' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Generate a Collection
using RestSharp;

var client = new RestClient("https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection");
var request = new RestRequest(Method.POST);
request.AddHeader("x-api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Sample API\",\n  \"options\": {\n    \"folderStrategy\": \"Tags\",\n    \"enableOptionalParameters\": true\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Generate a Collection
import Foundation

let headers = [
  "x-api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Sample API",
  "options": [
    "folderStrategy": "Tags",
    "enableOptionalParameters": true
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.getpostman.com/specs/73e15000-bc7a-4802-b80e-05fff18fd7f8/generations/collection")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```